'{-------------------------------------------------------------------
'SongMonitor.vbs, Sept-14-2004
'MediaMonkey 2.2.2 (or above) VBScript, by Peke
'
'How to install: 1. Unpack Archive in some folder (like c:\SongMonitor\)
'		 2. Copy Auto Folder to MediaMonkey Scripts Folder
'                3. Edit SongMonitor.vbs line 24. So that FilePath to Monitor.Exe is
'                    pointing to extracted folder
'                4. Copy Winamp Plugins to extracted folder (List of tested is below)
'                5. Copy OUT_DS.DLL to extracted folder as it needs it for playback
'                6. Restart MM if needed
'
'How to use it: Song Monitor will integrate itself in "Advanced" ToolBar
'                and "Send To..." Pop-up menu of Track View
'
'List of Working plugins: in_APE.dll, in_CDReader.dll, in_flac.dll, in_midi.dll, 
'                         in_mod.dll, in_mp3.dll, in_mp4.dll, in_mpc.dll, in_vorbis.dll,
'                         in_wave.dll, in_wm.dll, out_ds.dll
'
'List of nonWorking Plugins: in_mpg123, in_tara
'-------------------------------------------------------------------}

' --> Here change FullPath to Monitor.exe if needed
MonitorEXE = "c:\program files\MediaMonkey\Scripts\Monitor\Monitor.exe"

Sub OnStartup

  Dim SMonitor
  Set SMonitor = SDB.UI.AddMenuItem(SDB.UI.Menu_TbAdvanced,0,0)
  SMonitor.Caption = "Monitor Song"
  SMonitor.OnClickFunc = "PlayMonitor"
  SMonitor.UseScript = Script.ScriptPath
  SMonitor.IconIndex = 63
  
  Dim SPreview
  Set SPreview = SDB.UI.AddMenuItem(SDB.UI.Menu_TbAdvanced,0,0)
  SPreview.Caption = "Play Song Preview"
  SPreview.OnClickFunc = "PlayPreview"
  SPreview.UseScript = Script.ScriptPath
  SPreview.IconIndex = 16
  
  Dim POPSMonitor
  Set POPSMonitor = SDB.UI.AddMenuItem(SDB.UI.Menu_Pop_TrackList_SendTo,0,-3)
  POPSMonitor.Caption = "Monitor Song"
  POPSMonitor.OnClickFunc = "PlayMonitor"
  POPSMonitor.UseScript = Script.ScriptPath
  POPSMonitor.IconIndex = 40

  Dim POPSPreview
  Set POPSPreview = SDB.UI.AddMenuItem(SDB.UI.Menu_Pop_TrackList_SendTo,0,-3)
  POPSPreview.Caption = "Play Song Preview"
  POPSPreview.OnClickFunc = "PlayPreview"
  POPSPreview.UseScript = Script.ScriptPath
  POPSPreview.IconIndex = 18
  
End Sub

Sub PlayMonitor(arg)
Dim WShell, Command, Result, Song

If SDB.SelectedSongList.count = 0 Then
  Result = SDB.MessageBox( "You need to select track, please.", mtError, Array(mbOk))
  Exit sub
END IF
Set Song = SDB.SelectedSongList.item(0)
Set WShell = CreateObject("WScript.Shell")
If (Song.Cached <> 1) Then
  If (Left(Song.Path,1) = "?") Then
    Result = SDB.MessageBox( "Selected Track is not available", mtError, Array(mbOk))
    Exit sub
  Else
    Command = Chr(34)&MonitorEXE&Chr(34)&" "&Chr(34)&Song.Path&CHR(34)
  End If
Elseif (Song.Cached = 1) Then
  Command = Chr(34)&MonitorEXE&Chr(34)&" "&Chr(34)&Song.CachedPath&CHR(34)
Else
  
End If
Result = WShell.Run(Command, 1, 1)
if result = 1 then
  SDB.Player.PlaylistAddTrack(Song)
  Call SDB.Player.PlaylistMoveTrack(SDB.Player.PlaylistCount-1, SDB.Player.CurrentSongIndex+1)
ElseIf Result = 2 Then
' If Result is 1 Add Play Last in now playing
  SDB.Player.PlaylistAddTrack(Song)
ElseIf Result = 3 Then
' If Result is 1 Add Play Now in now playing
  SDB.Player.PlaylistClear
  SDB.Player.PlaylistAddTrack(Song)
  SDB.Player.Stop
  SDB.player.play
End if
End Sub

Sub PlayPreview(arg)
Dim WShell, Command, Result, Song

If SDB.SelectedSongList.count = 0 Then
  Result = SDB.MessageBox( "You need to select track, please.", mtError, Array(mbOk))
  Exit sub
END IF

If SDB.SelectedSongList.item(0).Preview = 0 Then
  Result = SDB.MessageBox( "Selected Track do not have Preview.", mtError, Array(mbOk))
  Exit sub
END IF
Set Song = SDB.SelectedSongList.item(0)
Set WShell = CreateObject("WScript.Shell")
Command = Chr(34)&MonitorEXE&Chr(34)&" "&Chr(34)&Song.PreviewPath&CHR(34)
Result = WShell.Run(Command, 1, 1)
if result = 1 then
  SDB.Player.PlaylistAddTrack(Song)
  Call SDB.Player.PlaylistMoveTrack(SDB.Player.PlaylistCount-1,SDB.Player.CurrentSongIndex+1)
ElseIf Result = 2 Then
' If Result is 1 Add Play Last in now playing
  SDB.Player.PlaylistAddTrack(Song)
ElseIf Result = 3 Then
' If Result is 1 Add Play Now in now playing
  SDB.Player.PlaylistClear
  SDB.Player.PlaylistAddTrack(Song)
  SDB.Player.Stop
  SDB.player.play
End if
End Sub
